//
// ======== ByteFramedInput.java ========
//
// generated by GenModule.java
//
 
/**
 * This handles any byte framed input device..
 *
 * @version    1.0, Sun Mar 24 10:02:06  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
abstract public class ByteFramedInput extends FramedInput {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream byteStream;
   NeatInputStream frameMarker;
   NeatOutputStream out_byteStream;
 
   /**
    * Non-stream custom fields.
    */
   CircularBuffer buffer;
 
int putbytecount;
 
   /**
    * Constructor for ByteFramedInput
    */
   protected ByteFramedInput() {
      super();
	  putbytecount = 0;
      byteStream = new NeatInputStream( IOstream.BYTE );
      inputStreams.addElement( byteStream );
      frameMarker = new FixedByteStream( (byte)0 );
      inputStreams.addElement( frameMarker );
      out_byteStream = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_byteStream );
 
      // non-stream constructor initializations...
      buffer = new CircularBuffer( 100 );
   }
 
 
   /**
    * Generated function updateBuffer*
    */
   public void updateBuffer() {
      // read bytes into local buffer
      while ( byteStream.dataAvailable && ( buffer.freeBytes() > 0 )) {
	  putbytecount++;
         buffer.putByte( byteStream.getByte() );
      }
   }
 
 public void debugInfo() {
	super.debugInfo();
	System.out.println( "put byte count is: " + putbytecount );
}
 
   /**
    * Generated function frameDetected*
    */
   public boolean frameDetected() {
      // if bytes exist and are the appropriate distance apart, a frame has been found
      return ( buffer.hasBytes( frameMarker.getByte() ) && ( buffer.byteDistance() == ( dataFrameSize.getInt() + 1 )));
      
   }
 
 
   /**
    * Generated function cleanupBuffer*
    */
   public void cleanupBuffer() {
      if ( buffer.usedBytes() > ( dataFrameSize.getInt() * 2 )) {
         // the circular buffer has found enough bytes for a frame, but no frame has been 
         // found.  Shift the start location in the buffer to the right.
         buffer.startShift( dataFrameSize.getInt() );
      }
   }
}
